<?php
/*
Title: Multilayer

Verifica se o layer e multilayer

Analisa um mapfile e retorna a situao de agrupamento das camadas.

About: Licena

I3Geo Interface Integrada de Ferramentas de Geoprocessamento para Internet

Direitos Autorais Reservados (c) 2006 Ministrio do Meio Ambiente Brasil
Desenvolvedor: Edmar Moretti edmar.moretti@mma.gov.br

Este programa  software livre; voc pode redistribu-lo
e/ou modific-lo sob os termos da Licena Pblica Geral
GNU conforme publicada pela Free Software Foundation;
tanto a verso 2 da Licena.
Este programa  distribudo na expectativa de que seja til,
porm, SEM NENHUMA GARANTIA; nem mesmo a garantia implcita
de COMERCIABILIDADE OU ADEQUAO A UMA FINALIDADE ESPECFICA.
Consulte a Licena Pblica Geral do GNU para mais detalhes.
Voc deve ter recebido uma cpia da Licena Pblica Geral do
GNU junto com este programa; se no, escreva para a
Free Software Foundation, Inc., no endereo
59 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

File: classe_vermultilayer.php

19/6/2007
*/
/*
Class: vermultilayer
*/
class vermultilayer
{
	/*
	Variable: $resultado
	
	Indica se  multi-layer ou no (0 ou 1)
	*/
	var $resultado;
	/*
	Variable: $temas
	
	Lista de cdigos dos temas
	*/
	var $temas; //lista de nomes de temas se for um grupo
	/*
	Variable: $layers
	
	Lista de objetos layers
	*/
	var $layers; //lista de objetos temas se for um grupo
	/*
	Variable: $nomes
	
	Lista de nomes dos temas
	*/
	var $nomes; //lista de nomes se for um grupo
	/*
	Variable: $nomesvisiveis
	
	Lista dos nomes dos temas visveis
	*/
	var $nomesvisiveis; //nomes dos temas visveis na escala
	/*
	Variable: $temasvisiveis
	
	Lista com os cdigos dos temas visveis
	*/
	var $temasvisiveis; //temas vi'siveis na escala
	/*
	function: verifica
	
	Verifica se um tema  multilayer
	
	parameters:
	$mapfile - arquivo mapfile
	
	$tema - cdigo do tema que ser verificado
	*/
	function verifica($mapfile,$tema) //$mapfile = arquivo .map, $tema = nome do layer
	{
		$map = ms_newMapObj($mapfile);
		$map->preparequery();
		$escala = $map->scale;
		$todoslayers = $map->getAlllayernames();
		$multilayer = 0;
		foreach ($todoslayers as $temai)
		{
			$layer = $map->getlayerbyname($temai);
			$testa = 0;
			//verifica se o tema  visivel na escala
			$mins = $layer->minscale;
			$maxs = $layer->maxscale;
			if ($mins != $maxs)
			{
				$testa = 1;
				if ($mins > 0)
				{
					if ($escala >= $mins)
					{$testa = 0;}
				}
				if ($maxs > 0)
				{
					if ($escala <= $maxs)
					{$testa = 0;}
					else {$testa = 1;}
				}
				if (($mins > 0) && ($maxs > 0))
				{
					if (($escala >= $mins) && ($escala <= $maxs))
					{$testa = 0;}
					else {$testa = 1;}
				}
			}
			if ($layer->getmetadata("escondido") != "SIM")
			{
				if (($layer->group == $tema) && ($layer->type != 4))
				{
					$multilayer = 1;
					$temas[] = $temai;
					$layers[] = $layer;
					$nomes[] = pegaNome($layer);
					if ($testa == 0)
					{
						$nomesvisiveis[] = pegaNome($layer);
						$temasvisiveis[] = $temai;
					}
				}
			}
		}
		$this->resultado = $multilayer;
		$this->temas = $temas;
		$this->layers = $layers;
		$this->nomes = $nomes;
		$this->nomesvisiveis = $nomesvisiveis;
		$this->temasvisiveis = $temasvisiveis;
	}
}
?>