<?php
/*
Title: Variveis de inicializao.

Armazena as variveis de inicializao necessrias ao funcionamento do I3Geo.

O ms_configura  includo em vrios programas do I3Geo.

As variveis de configurao devem ser definidas para linux e windows.

File: ms_configura.php

About: Licena

I3Geo Interface Integrada de Ferramentas de Geoprocessamento para Internet

Direitos Autorais Reservados (c) 2006 Ministrio do Meio Ambiente Brasil
Desenvolvedor: Edmar Moretti edmar.moretti@mma.gov.br

Este programa  software livre; voc pode redistribu-lo
e/ou modific-lo sob os termos da Licena Pblica Geral
GNU conforme publicada pela Free Software Foundation;
tanto a verso 2 da Licena.
Este programa  distribudo na expectativa de que seja til,
porm, SEM NENHUMA GARANTIA; nem mesmo a garantia implcita
de COMERCIABILIDADE OU ADEQUAO A UMA FINALIDADE ESPECFICA.
Consulte a Licena Pblica Geral do GNU para mais detalhes.
Voc deve ter recebido uma cpia da Licena Pblica Geral do
GNU junto com este programa; se no, escreva para a
Free Software Foundation, Inc., no endereo
59 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

About: Variveis

editores - ip dos usuarios que podem administrar via navegador

dir_tmp - caminho completo do diretrio temporrio utilizado pelo mapserver

temasdir - caminho completo do diretrio onde ficam os arquivos .map correspondentes aos temas disponveis

temasaplic - caminho completo onde ficam os arquivos .map especficos do I3Geo

locmapserv - localizao do executvel do Mapserver conforme deve ser acrescentado a URL aps o nome do host

locaplic - caminho completo onde fica o I3Geo

locsistemas - onde fica o xml, relativo ao diretrio i3geo, que ser embutido na lista de temas com sistemas locais, se for "" no ser feita nenhuma incluso

locidentifica - onde fica o xml, relativo ao diretrio i3geo, que ser embutido na lista de identificacao, se for "" no ser feita nenhuma incluso

locmapas - onde fica o xml, para preencher a guia mapas. Se for vazio a guia no ser mostrada no mapa

R_path - onde esta o executavel do pacote R. O R  um pacote estatstico utilizado pelo I3Geo para gerao de grficos e anlises estatsticas. Se vc no possui o R instalado, comente a linha abaixo

postgis_con - string de conexo com o banco de dados postgis para realizao de clculos, se no existir, deixe em branco

srid_area - srid utilizado nos clculos que exigem projeo equivalente

postgis_mapa - string de conexo com o banco de dados para substituio do CONNECTION " ". Os layers que tiverem CONNECTION " " tero a string de conexo substituda por esse valor.
*/
$mensagemInicia = "I3Geo verso 3.7";
if (strtoupper(substr(PHP_OS, 0, 3) == 'WIN'))
{
	//ip dos usuarios que podem navegar no servidor para acessar arquivos de dados geogrficos 
	$navegadoresLocais = array(
							array(
							"ip"=>"127.0.0.1",
							"drives"=>array(
										array("caminho"=>"c:/","nome"=>"c"),
										array("caminho"=>"d:/","nome"=>"d")
										)
							)
						);
	//ip dos usuarios que podem administrar via navegador. Separe os ips por vrgula
	$editores = array("127.0.0.1");
	//caminho completo do diretrio temporrio utilizado pelo mapserver
	$dir_tmp = "c:/ms4w/tmp/ms_tmp";
	//caminho completo onde fica o I3Geo
	$locaplic = "c:/ms4w/apache/htdocs/i3geo";
	//caminho completo do diretrio onde ficam os arquivos .map correspondentes aos temas disponveis
	$temasdir = $locaplic."/temas"; //"c:/ms4w/apache/htdocs/i3geo/temas";
	//caminho completo onde ficam os arquivos .map especficos do I3Geo
	$temasaplic = $locaplic."/aplicmap";//"c:\ms4w\apache\htdocs\i3geo\aplicmap";
	//localizao do executvel do Mapserver conforme deve ser acrescentado a URL aps o nome do host
	$locmapserv = "/cgi-bin/mapserv.exe";
	// onde fica o xml, relativo ao diretrio i3geo, que ser embutido na lista de temas com sistemas locais, se for "" no ser feita nenhuma incluso
	$locsistemas = "http://localhost/i3geo/menutemas/sistemas.xml";
	// onde fica o xml, relativo ao diretrio i3geo, que ser embutido na lista de identificacao, se for "" no ser feita nenhuma incluso
	$locidentifica = "http://localhost/i3geo/menutemas/identifica.xml";
	// onde fica o xml, para preencher a guia mapas. Se for vazio a guia no ser mostrada no mapa
	//$locmapas = "http://mapas.mma.gov.br/abremapa.php?id=xml";
	$locmapas = "http://localhost/i3geo/menutemas/mapas.xml";
	//onde esta o executavel do pacote R
	//o R  um pacote estatstico utilizado pelo I3Geo para gerao de grficos e anlises estatsticas
	//se vc no possui o R instalado, comente a linha abaixo
	$R_path = "c:/r/win/bin/R.exe";
	//string de conexo com o banco de dados postgis utilizada para reallizao de clculos
	//se no existir, deixe em branco
	$postgis_con = "";
	//srid utilizado nos clculos que exigem projeo equivalente
	$srid_area = 1;
	//string de conexo para acesso aos dados
	//os mapfiles do diretrio temas que tiverem CONNECTION " ", tero a string de conexo substituda por esse valor
	//se no for desejado a substituio, deixe essa varivel em branco
	$postgis_mapa = "";
	//array com a lista de arquivos xml que sero incluidos na guia de adio de temas
	/*
	$menutemas = array(
		array("idmenu"=>1,"arquivo"=>"http://localhost/i3geo/menutemas/menutemas.xml"),
		array("idmenu"=>2,"arquivo"=>"http://localhost/i3geo/menutemas/menutemas2.xml")
		);
	*/
	$menutemas = "";
}
else //se for linux
{
	$editores = array("127.0.0.1");
	$dir_tmp = "/var/tmp/ms_tmp";
	$temasdir = "/opt/www/html/i3geo/temas";
	$temasaplic = "/opt/www/html/i3geo/aplicmap";
	$locmapserv = "/cgi-bin/mapserv";
	$locaplic = "/opt/www/html/i3geo";
	$locsistemas= "http://localhost/i3geo/menutemas/sistemas.xml";
	$locidentifica = "http://localhost/i3geo/menutemas/identifica.xml";
	$locmapas = "http://localhost/abremapa.php?id=xml";
	$R_path = "R";//se vc no instalou o R no seu servidor, tente o endereo $R_path = $locaplic."/pacotes/r/linux/r";
	$postgis_con = ""; //"user= password= dbname= host= port=5432";
	$srid_area = 1;
	$postgis_mapa = "";
	/*
	$menutemas = array(
		array("idmenu"=>1,"arquivo"=>"http://mapas.mma.gov.br/i3geo/menutemas/menutemas.xml")
		);
	*/
	$menutemas = "";
}
?>
